class VowelWalker
  include Enumerable
  
  def initialize(str)
    @str = str
  end
  
  def each
    @str.scan(/[aoeuiy]/).each do |vowel|
      yield vowel
    end
  end
end

VowelWalker.new('Test string').each do |vowel|
  puts vowel
end

puts VowelWalker.new('Hello world').first(2)